//
// FearCheck.js
//
// Select a token and run this script to have a spirit roll completed and then a roll against
// the fear table on failure.  Takes the fear modifier into account.
//


main();

async function main()
{
  // this boolean is used to determine if we exit the script due to an error
  let runScript = true;

  // Needs to be exactly one selection and one target
if (canvas.tokens.controlled.length != 1) {
  ui.notifications.warn("Need Exactly One Selected Token");
  runScript = false;
}

if (runScript) {
    // Selected token --> The attacker
    let selected = canvas.tokens.controlled[0].document.actor;

    // The strength of the selected token - the attacker
    let selectedSpirit = selected.system.attributes.spirit.die

    let form = `
    <form id="diceForm" class="flexcol">
      <div class="form-group">
        <label for="modLeaf">Fear Penalty (include - sign):</label>
        <input type="text" name="modLeaf" placeholder="Enter Modifier" value="0">

    </form>
  `;

  let diceDialog = new Dialog({
    title: 'Enter Number of Each Dice Set:',
    content: form,
    buttons: {
      no: {
        icon: '<i class="fas fa-times"></i>',
        label: 'Cancel'
      },
      yes: {
        icon: '<i class="fas fa-check"></i>',
        label: 'Roll',
        callback: async (html) => {

  

            let modifier = html.find('[name="modLeaf"]').val();
            
            // Need to include wild die in Roll....
            let rollString = "{1d6x,1d" + selectedSpirit.sides + "x}kh1 + " + modifier;
            console.log("roll String:" + rollString);
            let fearRoll = new Roll(rollString);
            //console.log("Roll:" + fearRoll.toMessage());

            await fearRoll.evaluate();
            let fearRollResult = fearRoll.total;
            console.log("Fear Roll:" + fearRollResult);
            let chatString = "<p>Rolling for " + selected.name + "with spirit 1d" + selectedSpirit.sides + "=" + fearRollResult + "</p>";

            if (fearRollResult >= 4)
            {
                chatString = chatString + "<b>Succeeded<b>";
            } else {
                chatString = chatString + "<b>Failed</b>";

                chatString = chatString + "<p> Fear Table Result: ";

                let feartableRoll = new Roll("1d20 + @mod", {mod: -modifier});
                await feartableRoll.evaluate();
                console.log("Fear Table Roll " + feartableRoll.total);
                let total=parseInt(feartableRoll.total);
                // should be a roll table but don't want people to set it up!
                switch (total)
                {
                    case 1:
                    case 2:
                    case 3:
                                chatString = chatString + "<b>Adrenaline Surge</b>";
                        break;
                    case 4:
                    case 5:
                    case 6:
                        chatString = chatString + "<b>Distracted</b>";
                        break;
                    case 7:
                    case 8:
                    case 9:
                        chatString = chatString + "<b>Vulnerable</b>";
                        break;
                    case 10:
                    case 11:
                    case 12:
                        chatString = chatString + "<b>Shaken</b>";
                        break;
                    case 13:
                        chatString = chatString + "<b>The Mark of Fear</b>";
                        break;
                    case 14:
                    case 15:
                        chatString = chatString + "<b>Frightened</b>";
                        break;
                    case 16:
                    case 17:
                        chatString = chatString + "<b>Panicked</b>";
                        break;
                    case 18:
                    case 19:
                        chatString = chatString + "<b>Minor Phobia</b>";
                        break;
                    case 20:
                    case 21:
                        chatString = chatString + "<b>Major Phobia</b>";
                        break;
                    default:
                        chatString = chatString + "<b>Heart Attack</b>";
                        break;
                    
    
                }
            }
                console.log(chatString);
            ChatMessage.create({ content: chatString });

        }
      },
    },
    default: 'yes',
    close: () => {
      console.log('Example Dialog Closed');
    }
  }).render(true);

}
}